                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Authors note:   |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/


#ifndef _TEXTUREUTILS_H_
#define _TEXTUREUTILS_H_

unsigned int getClosestPowerOfTwo(unsigned int x){
	int i,k;
	
	k = x;
	i = -1;
	while (k != 0){
		k >>= 1;
		i++;
	}
	return 1 << (i + ((x >> (i-1)) & 1));
}


/*void buildMipMap(unsigned char *dest, unsigned char *src, unsigned int width, unsigned int height, unsigned int channels, int flags){
	unsigned int x,y,i,res,base0, base1;
	unsigned int xOff = (width  <= 1)? 0:0xFFFFFFFF;
	unsigned int yOff = (height <= 1)? 0:1;
	float r,g,b, invLen;
	bool renormalize = (flags & TEXFLAGS_RENORMALIZE);

	for (y = 0; y < height; y += 2){
		for (x = 0; x < width; x += 2){
			base0 = (y * width + x) * channels;
			base1 = ((y + yOff) * width + x) * channels;

			if (renormalize){
		 		r = float(unsigned int(src[base0]) + 
				          unsigned int(src[base0 + (xOff & channels)]) +
				          unsigned int(src[base1]) +
				          unsigned int(src[base1 + (xOff & channels)])) - 510.0f;
		 		g = float(unsigned int(src[base0 + 1]) + 
				          unsigned int(src[base0 + (xOff & channels) + 1]) +
				          unsigned int(src[base1 + 1]) +
				          unsigned int(src[base1 + (xOff & channels) + 1])) - 510.0f;
		 		b = float(unsigned int(src[base0 + 2]) + 
				          unsigned int(src[base0 + (xOff & channels) + 2]) +
				          unsigned int(src[base1 + 2]) +
				          unsigned int(src[base1 + (xOff & channels) + 2])) - 510.0f;
				invLen = rsqrtf(r * r + g * g + b * b);
				*dest++ = (unsigned char) (127.5f * (r * invLen + 1.0f));
				*dest++ = (unsigned char) (127.5f * (g * invLen + 1.0f));
				*dest++ = (unsigned char) (127.5f * (b * invLen + 1.0f));
			} else {
				for (i = 0; i < channels; i++){
			 		res = (unsigned int(src[base0 + i]) + 
					       unsigned int(src[base0 + (xOff & channels) + i]) +
						   unsigned int(src[base1 + i]) +
						   unsigned int(src[base1 + (xOff & channels) + i]) + 2) >> 2;
					*dest++ = res;
				}
			}
		}
	}
}

void colorMipMap(unsigned char *dest, unsigned int width, unsigned int height, unsigned int channels, unsigned int level){
	static unsigned char mipmapColors[] = 
		{255,0,  0,  128,   0,  255,0,  128,   0,  0,  255,128,   255,255,0,128,
		 255,0,  255,128,   0,  255,255,128,   255,255,255,128,   255,0,  0,128};

	unsigned int k, len = width * height;
	unsigned char *src = mipmapColors + ((level & 7) << 2);

	do {
		for (k = 0; k < channels; k++){
			*dest++ = src[k];
		}
	} while (--len);

}
*/


/* ################################################################################################################# */


// Using OpenGL
#ifdef __GL_H__

void upload2DImage(GLenum target, unsigned char *&pixels, unsigned int &width, unsigned int &height, unsigned int &channels,
                   unsigned int &format, GLint &internalFormat, GLint &minFilter){

	unsigned int roundedWidth, roundedHeight;
	roundedWidth  = getClosestPowerOfTwo(width);
	roundedHeight = getClosestPowerOfTwo(height);

	if (roundedWidth != width || roundedHeight != height){
		rescale(pixels, width, height, channels, roundedWidth, roundedHeight, IMAGE_BILINEAR);
	}

	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);

	GLenum type;
	switch(channels){
	case 1:
		type = GL_LUMINANCE;
		break;
	case 2:
		type = GL_DUDV_ATI;
		break;
	case 3:
		type = GL_RGB;
		break;
	case 4:
		type = GL_RGBA;
		break;
	default:
		type = GL_RGB;
	}

	int imformat  = format & ~IMAGE_FORMAT_MIPMAPPED;
	int mipmapped = format &  IMAGE_FORMAT_MIPMAPPED;
	
	if (imformat >= IMAGE_FORMAT_COMPRESSED_DXT1 && imformat <= IMAGE_FORMAT_COMPRESSED_DXT5 &&
		!(GL_ARB_texture_compression && GL_EXT_texture_compression_s3tc)){
		
		// No S3TC support ... use normal RGB instead
		uncompressImage(pixels, width, height, channels, format);
		imformat = IMAGE_FORMAT_UNCOMPRESSED;
		internalFormat = (channels == 4)? GL_RGBA4:GL_RGB5;
	}
	
	switch(imformat){
	case IMAGE_FORMAT_UNCOMPRESSED:
		if (!mipmapped){
			if (minFilter != GL_NEAREST && minFilter != GL_LINEAR){
				mipmap(pixels, width, height, channels, format);
				mipmapped = true;
			}
		}

		if (mipmapped){
			unsigned int size, level = 1, w = width, h = height;
			unsigned char *src = pixels;
			
			glTexImage2D(target, 0, internalFormat, width, height, 0, type, GL_UNSIGNED_BYTE, pixels);
			do {
				size = w * h * channels;
				if (w > 1) w >>= 1;
				if (h > 1) h >>= 1;
				src += size;
				glTexImage2D(target, level++, internalFormat, w, h, 0, type, GL_UNSIGNED_BYTE, src);
			} while (w > 1 || h > 1);
		} else {
			glTexImage2D(target, 0, internalFormat, width, height, 0, type, GL_UNSIGNED_BYTE, pixels);
		}
		break;
	case IMAGE_FORMAT_COMPRESSED_DXT1:
	case IMAGE_FORMAT_COMPRESSED_DXT3:
	case IMAGE_FORMAT_COMPRESSED_DXT5:
		if (imformat == IMAGE_FORMAT_COMPRESSED_DXT1){
			if (channels == 3){
				internalFormat = GL_COMPRESSED_RGB_S3TC_DXT1_EXT;
			} else {
				internalFormat = GL_COMPRESSED_RGBA_S3TC_DXT1_EXT;
			}
		} else if (imformat == IMAGE_FORMAT_COMPRESSED_DXT3){
			internalFormat = GL_COMPRESSED_RGBA_S3TC_DXT3_EXT;
		} else {
			internalFormat = GL_COMPRESSED_RGBA_S3TC_DXT5_EXT;
		} 
		
        unsigned int bytesPerBlock = (imformat == IMAGE_FORMAT_COMPRESSED_DXT1)? 8 : 16;
        unsigned int size = ((width + 3) >> 2) * ((height + 3) >> 2) * bytesPerBlock;

		glCompressedTexImage2DARB(target, 0, internalFormat, width, height, 0, size, pixels);
		if (mipmapped){
			unsigned int level = 1, w = width, h = height;
			unsigned char *src = pixels;
			
			do {
				src += size;
				if (w > 1) w >>= 1;
				if (h > 1) h >>= 1;
                size = ((w + 3) >> 2) * ((h + 3) >> 2) * bytesPerBlock;

				glCompressedTexImage2DARB(target, level++, internalFormat, w, h, 0, size, src);
			} while (w > 1 || h > 1);
		}				
		break;
	}
}

void glDrawText(char *str, float x, float y, float charWidth, float charHeight){
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho(0,1,1,0,1,-1);

    float tx,ty, startx = x;

    while (*str){
        if (*str == '\n'){
            y += charHeight;
            x = startx;
        } else {
            tx = float(((unsigned char) *str) & 15) / 16;
            ty = float(((unsigned char) *str) >> 4) / 16;
			glBegin(GL_QUADS);
                glTexCoord2f(tx,ty);
                glVertex2f(x, y);

                glTexCoord2f(tx + 1.0f / 16,ty);
                glVertex2f(x + charWidth, y);

                glTexCoord2f(tx + 1.0f / 16,ty + 1.0f / 16);
                glVertex2f(x + charWidth, y + charHeight);

                glTexCoord2f(tx,ty + 1.0f / 16);
                glVertex2f(x, y + charHeight);
            glEnd();
            x += charWidth;
        }
        str++;
    }
}

#endif // __GL_H__

/* ################################################################################################################# */


// Using Direct3D
#ifdef _D3D8_H_

bool supports_A8R8G8B8 = false;
bool supports_X8R8G8B8 = false;
bool supports_R8G8B8   = false;
bool supports_DXT1     = false;
bool supports_DXT3     = false;
bool supports_DXT5     = false;

bool checkTextureFormat(D3DFORMAT adapterFormat, D3DFORMAT textureFormat){
	return (d3d->CheckDeviceFormat(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, adapterFormat, 0, D3DRTYPE_TEXTURE, textureFormat) == D3D_OK);
}

void checkTextureFormats(D3DFORMAT adapterFormat){
	supports_A8R8G8B8 = checkTextureFormat(adapterFormat, D3DFMT_A8R8G8B8);
	supports_X8R8G8B8 = checkTextureFormat(adapterFormat, D3DFMT_X8R8G8B8);
	supports_R8G8B8   = checkTextureFormat(adapterFormat, D3DFMT_R8G8B8);
	supports_DXT1     = checkTextureFormat(adapterFormat, D3DFMT_DXT1);
	supports_DXT3     = checkTextureFormat(adapterFormat, D3DFMT_DXT3);
	supports_DXT5     = checkTextureFormat(adapterFormat, D3DFMT_DXT5);
}



void upload2DImage(LPDIRECT3DTEXTURE8 &textureID, unsigned char *&pixels, unsigned int &width, unsigned int &height, unsigned int &channels,
                   unsigned int &format, D3DFORMAT &internalFormat){

	int imformat  = format & ~IMAGE_FORMAT_MIPMAPPED;
	int mipmapped = format &  IMAGE_FORMAT_MIPMAPPED;

	if (imformat == IMAGE_FORMAT_UNCOMPRESSED){
		
		// TODO: Fix D3DFMT_xxxx in case the current isn't supported
		switch (channels){
		case 1:
			break;
		case 2:
			break;
		case 3:
			addChannelWithValue(pixels, width, height, channels, 0, 0);
			if (internalFormat == D3DFMT_A8R8G8B8) internalFormat = D3DFMT_X8R8G8B8;
			break;
		case 4:
			if (internalFormat == D3DFMT_R8G8B8 || internalFormat == D3DFMT_X8R8G8B8) internalFormat = D3DFMT_A8R8G8B8;
			break;
		}
		
		flipChannels(pixels, width, height, channels);
		
		unsigned int roundedWidth, roundedHeight;
		roundedWidth  = getClosestPowerOfTwo(width);
		roundedHeight = getClosestPowerOfTwo(height);
		
		if (roundedWidth != width || roundedHeight != height){
			rescale(pixels, width, height, channels, roundedWidth, roundedHeight, IMAGE_BILINEAR);
		}
	} else if ((imformat == IMAGE_FORMAT_COMPRESSED_DXT1 && !supports_DXT1) ||
               (imformat == IMAGE_FORMAT_COMPRESSED_DXT3 && !supports_DXT3) ||
               (imformat == IMAGE_FORMAT_COMPRESSED_DXT5 && !supports_DXT5)){
		// No S3TC support ... use normal RGB instead
		uncompressImage(pixels, width, height, channels, format);
		imformat = IMAGE_FORMAT_UNCOMPRESSED;
		internalFormat = (channels == 4)? D3DFMT_A8R8G8B8:D3DFMT_X8R8G8B8;
	}

	D3DLOCKED_RECT rect;
	unsigned int size, level, w, h;
	unsigned char *src;

	switch(imformat){
	case IMAGE_FORMAT_UNCOMPRESSED:
		d3ddevice->CreateTexture(width, height, 0, 0, internalFormat, D3DPOOL_MANAGED, &textureID);

		if (!mipmapped) mipmap(pixels, width, height, channels, format);

		textureID->LockRect(0, &rect, NULL, 0);
		memcpy(rect.pBits, pixels, width * height * channels);
		textureID->UnlockRect(0);
		
		src = pixels;
		level = 1;
		w = width;
		h = height;
		do {
			size = w * h * channels;
			if (w > 1) w >>= 1;
			if (h > 1) h >>= 1;
			src += size;
			
			textureID->LockRect(level, &rect, NULL, 0);
			memcpy(rect.pBits, src, w * h * channels);
			textureID->UnlockRect(level);
			level++;
		} while (w > 1 || h > 1);
		break;
	case IMAGE_FORMAT_COMPRESSED_DXT1:
	case IMAGE_FORMAT_COMPRESSED_DXT3:
	case IMAGE_FORMAT_COMPRESSED_DXT5:
		if (imformat == IMAGE_FORMAT_COMPRESSED_DXT1){
			internalFormat = D3DFMT_DXT1;
		} else if (imformat == IMAGE_FORMAT_COMPRESSED_DXT3){
			internalFormat = D3DFMT_DXT3;
		} else {
			internalFormat = D3DFMT_DXT5;
		}
		d3ddevice->CreateTexture(width, height, mipmapped? 0:1, 0, internalFormat, D3DPOOL_MANAGED, &textureID);
		
        unsigned int bytesPerBlock = (imformat == IMAGE_FORMAT_COMPRESSED_DXT1)? 8 : 16;
        size = ((width + 3) >> 2) * ((height + 3) >> 2) * bytesPerBlock;

		textureID->LockRect(0, &rect, NULL, 0);
		memcpy(rect.pBits, pixels, size);
		textureID->UnlockRect(0);
		if (mipmapped){
			
			src = pixels;
			level = 1;
			w = width;
			h = height;
			
			 while (w > 1 || h > 1){
				src += size;
				if (w > 1) w >>= 1;
				if (h > 1) h >>= 1;
                size = ((w + 3) >> 2) * ((h + 3) >> 2) * bytesPerBlock;

				textureID->LockRect(level, &rect, NULL, 0);
				memcpy(rect.pBits, src, size);
				textureID->UnlockRect(level);
				level++;
			}
		}				
		break;
	}
}

void uploadCubeMap(LPDIRECT3DCUBETEXTURE8 &textureID, unsigned char **pixels, unsigned int &width, unsigned int &height, unsigned int &channels,
                   unsigned int &format, D3DFORMAT &internalFormat){

	int imformat  = format & ~IMAGE_FORMAT_MIPMAPPED;
	int mipmapped = format &  IMAGE_FORMAT_MIPMAPPED;

	unsigned int i, ch;

	if (imformat == IMAGE_FORMAT_UNCOMPRESSED){
		
		// TODO: Fix D3DFMT_xxxx in case the current isn't supported
		switch (channels){
		case 1:
			break;
		case 2:
			break;
		case 3:
			for (i = 0; i < 6; i++){
				ch = 3;
				addChannelWithValue(pixels[i], width, height, ch, 0, 0);
			}
			channels = 4;
			if (internalFormat == D3DFMT_A8R8G8B8) internalFormat = D3DFMT_X8R8G8B8;
			break;
		case 4:
			if (internalFormat == D3DFMT_R8G8B8 || internalFormat == D3DFMT_X8R8G8B8) internalFormat = D3DFMT_A8R8G8B8;
			break;
		}
		
		for (i = 0; i < 6; i++){
			flipChannels(pixels[i], width, height, channels);
		}
		
		unsigned int roundedWidth, roundedHeight;
		roundedWidth  = getClosestPowerOfTwo(width);
		roundedHeight = getClosestPowerOfTwo(height);
		
		if (roundedWidth != width || roundedHeight != height){
			for (i = 0; i < 6; i++){
				rescale(pixels[i], width, height, channels, roundedWidth, roundedHeight, IMAGE_BILINEAR);
			}
		}
	}

	D3DLOCKED_RECT rect;
	unsigned int size, level, w, h;
	unsigned char *src;

	d3ddevice->CreateCubeTexture(width, 0, 0, internalFormat, D3DPOOL_MANAGED, &textureID);

	switch(imformat){
	case IMAGE_FORMAT_UNCOMPRESSED:
		for (i = 0; i < 6; i++){
			if (!mipmapped) mipmap(pixels[i], width, height, channels, format);

			level = 1;
			w = width;
			h = height;
			src = pixels[i];
			D3DCUBEMAP_FACES face = (D3DCUBEMAP_FACES) (D3DCUBEMAP_FACE_POSITIVE_X + i);
			
			textureID->LockRect(face, 0, &rect, NULL, 0);
			memcpy(rect.pBits, src, width * height * channels);
			textureID->UnlockRect(face, 0);
			
			while (w > 1 || h > 1){
				size = w * h * channels;
				if (w > 1) w >>= 1;
				if (h > 1) h >>= 1;
				src += size;
				
				if (textureID->LockRect(face, level, &rect, NULL, 0) == D3D_OK){
					memcpy(rect.pBits, src, w * h * channels);
					textureID->UnlockRect(face, level);
				}
				level++;
			}
		}
		break;
	}

}

void d3dDrawText(char *str, float x, float y, float charWidth, float charHeight){
	D3DXMATRIX mat;
	
	D3DXMatrixIdentity(&mat);
	d3ddevice->SetTransform(D3DTS_VIEW, &mat);

	D3DXMatrixOrthoOffCenterLH(&mat, 0, 1, 1, 0, -1, 1);
	d3ddevice->SetTransform(D3DTS_PROJECTION, &mat);

	struct {
		float x,y,z;
		float u, v;
	} quadVertices[4];


	quadVertices[0].z = quadVertices[1].z = quadVertices[2].z = quadVertices[3].z = 0;


    float tx,ty, startx = x;

    while (*str){
        if (*str == '\n'){
            y += charHeight;
            x = startx;
        } else {
            tx = float(((unsigned int) *str) & 15) / 16;
            ty = float(((unsigned int) *str) >> 4) / 16;
            
			quadVertices[0].x = x;
			quadVertices[0].y = y;
			quadVertices[0].u = tx;
			quadVertices[0].v = ty;

			quadVertices[1].x = x + charWidth;
			quadVertices[1].y = y;
			quadVertices[1].u = tx + 1.0f / 16;
			quadVertices[1].v = ty;
			
			quadVertices[2].x = x + charWidth;
			quadVertices[2].y = y + charHeight;
			quadVertices[2].u = tx + 1.0f / 16;
			quadVertices[2].v = ty + 1.0f / 16;
			
			quadVertices[3].x = x;
			quadVertices[3].y = y + charHeight;
			quadVertices[3].u = tx;
			quadVertices[3].v = ty + 1.0f / 16;

			d3ddevice->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, quadVertices, 5 * sizeof(float));

            x += charWidth;
        }
        str++;
    }
}

#endif // _D3D8_H_



#endif // _TEXTUREUTILS_H_
