#ifndef _INIREADER_H_
#define _INIREADER_H_


class IniReader {
private:
	Tokenizer tok;
public:
	IniReader(char *fileName){
		tok.setFile(fileName);
	}

	bool getString(char *value, char *variableName){
		tok.reset();
		while (tok.next(value)){
			if (stricmp(variableName, value) == 0){
				if (tok.next(value) && *value == '='){
					if (tok.next(value)){
						return true;
					}
				}
			}
		}
		return false;
	}

	bool getInt(int &value, char *variableName){
		char str[256];

		if (getString(str, variableName)){
			value = atoi(str);
			return true;
		}

		return false;
	}

	bool getFloat(float &value, char *variableName){
		char str[256];

		if (getString(str, variableName)){
			value = (float) atof(str);
			return true;
		}

		return false;
	}

	bool getBool(bool &value, char *variableName){
		char str[256];

		if (getString(str, variableName)){
			if (stricmp(str, "True") == 0){
				value = true;
			} else if (stricmp(str, "False") == 0){
				value = false;
			} else {
				value = (atoi(str) != 0);
			}
			return true;
		}

		return false;
	}
};


#endif // _INIREADER_H_