                  /*--.          .-"-. 
                 /   ._.        /  ` \
                 \_  (__\       \_v_/
                 //   \\        //   \\
                ((     ))      ((     ))
 --""---""----""---""--
                  |||            |||                                               
   Authors note:   |              |                                                
                                                                                   
   This file is part of work done by Emil Persson, aka Humus.                      
   You're free to use the code in any way you like, modified, unmodified           
   or cut'n'pasted into your own work. But for the good of the whole               
   programming community I will ask you to as long as possible and to the          
   extent you find suitable to follow these points:                                
    * If you use this file and it's contents unmodified, please leave this note.   
    * If you use a major part of the file in your app, please credit the author(s) 
      in one way or the other as you find suitable, for instance a small notice    
      in the readme file may do, or perhaps a link to the authors site.            
    * Share your work and ideas too as much as you can.                            
     _______                                                                       
   /` _____ `\;,    Humus                                                          
  (__(^===^)__)';,  emiper-8@student.luth.se                         ___           
    /  :::  \   ,;  ICQ #47010716                                  /^   ^\         
   |   :::   | ,;'                                                (     )        
 '._______.'`--oOo--(_)--oOo--*/


#ifndef _SHADER_H_
#define _SHADER_H_

typedef int ShaderID;

#define SHADER_DISABLED (-1)

/* ################################################################################################################### */

class VertexShader {
protected:
    DWORD shaderID;
public:
    VertexShader(){
	
	}

    ~VertexShader(){
	
	}


    bool activate(){
        
        return true;
    }

    static void deactivate(){
		//d3ddevice->SetVertexShader(NULL);
    }
};


/* ################################################################################################################### */

class FragmentShader {
protected:
    DWORD shaderID;
public:
    FragmentShader(const char *shaderCode){
		LPD3DXBUFFER pCode;
		LPD3DXBUFFER pError;

		shaderID = 0;
			
		if (D3DXAssembleShader(shaderCode, strlen(shaderCode), D3DXASM_DEBUG, NULL, &pCode, &pError) != D3D_OK){
			::MessageBox(NULL, (const char *) pError->GetBufferPointer(), "Can't assemble", MB_OK);
		}
		if (d3ddevice->CreatePixelShader((DWORD *) pCode->GetBufferPointer(), &shaderID) != D3D_OK){
			::MessageBox(NULL, "Can't create", "fel!!", MB_OK);
		}
		if (pCode != NULL) pCode->Release();
		if (pError != NULL) pError->Release();
	}
    
	~FragmentShader(){
		if (shaderID != 0) d3ddevice->DeletePixelShader(shaderID);
	}

    bool activate(){
		d3ddevice->SetPixelShader(shaderID);
		return true;
	}

    static void deactivate(){
		d3ddevice->SetPixelShader(NULL);
	}
};



/* ################################################################################################################### */


#endif // _SHADER_H_